SystemOrganization addCategory: 'tODE-GemStone-Debugger'!

!GsProcess methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 06/08/2011 15:34'!
renderDebugTabOn: html spec: aTOTabSpec tOdeMain: main

	(aTOTabSpec renderer)
		frame: aTOTabSpec frame;
		renderContentOn: html main: main! !

!GsProcess methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 06/08/2011 15:45'!
tODEDebugTabSpec
	<tODECenterTabSpec>
	| toProcess |
	toProcess := (TOGsProcess new) process: self; yourself.
	^ (TOTabSpec new)
		id: #debug;
		renderer: toProcess;
		receiver: self;
		label: 'debug';
		order: 75;
		group: 'basic';
		sidebarSpec: toProcess tODEDebugFrameSidebarSpec;
		renderSelector: #renderDebugTabOn:spec:tOdeMain:! !

TOAbstractProcess subclass: #TOGsProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-GemStone-Debugger'!

!TOGsProcess methodsFor: 'accessing' stamp: 'dkh 06/08/2011 15:15'!
label

	^'exception'! !

!TOGsProcess methodsFor: 'accessing' stamp: 'dkh 06/08/2011 15:16'!
process

	^self object! !

!TOGsProcess methodsFor: 'accessing' stamp: 'dkh 06/08/2011 14:59'!
process: aGsProcess

	| context stackFrame next |
	self object: aGsProcess.
	context := aGsProcess suspendedContext.
	frames := OrderedCollection new.
	topOfStack := stackFrame := (TOStackFrame new) context: context; parent: self; yourself.
	[ context isNil ] whileFalse: [
		frames add: stackFrame.
		context := context sender.
		context ifNotNil: [
			next :=  (TOStackFrame new) context: context; parent: self; yourself.
			stackFrame next: next.
			next previous: stackFrame.
			stackFrame := next ] ].! !

!TOGsProcess methodsFor: 'rendering' stamp: 'dkh 06/08/2011 15:33'!
renderContentOn: html main: main
	html
		paragraph: [ 
			html text: 'To debug, select '.
			self
				renderLink: [ :s | 
					self currentSession push: self topOfStack selecting: #debug.
					main updateCenterSideHistory: s ]
				with: 'topOfStack'
				on: html.
			html text: ' or a frame from the list on your left.' ]! !

!TOException methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 06/08/2011 15:10'!
exception: anException

	self object: anException.
	self createFramesFrom: (GsProcess continuationFromLevel: 2) suspendedContext! !

!OGStackFrame methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:22'!
home

	^self outerContext! !

!OGStackFrame methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:27'!
numArgs

	^self selector numArgs! !

!OGStackFrame methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:01'!
outerContext

	| hc |
	hc := self homeContext.
	hc == self ifTrue: [^nil ].
	^hc! !

!OGStackFrame methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:24'!
sourceCode

	^self sourceString! !

!OGStackFrame methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:29'!
tempNamed: aString

	| i |
	i := self tempNames indexOf: aString.
	^self tempAt: i! !

!TOContextInspector methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:29'!
getArgMembers
	| members tempNames |
	members := OrderedCollection new.
	tempNames := self context tempNames.
	1 to: self context numArgs do: [ :index | 
		| each |
		each := tempNames at: index.
		members
			add:
				((TOInspectorKeylessFieldSpec new)
					keyLabel: each;
					value: (self context tempNamed: each)) ].
	^ members! !

!TOContextInspector methodsFor: '*tode-gemstone-debugger' stamp: 'dkh 05/21/2011 04:31'!
getContextMembers
	| members tempNames |
	members := OrderedCollection new.
	members
		add:
			((TOInspectorKeylessFieldSpec new)
				keyLabel: 'thisContext';
				value: self context).
	tempNames := self context tempNames.
	self context numArgs + 1 to: tempNames size do: [ :index | 
		members
			add:
				((TOInspectorKeylessFieldSpec new)
					keyLabel: (tempNames at: index);
					value: (self context tempAt: index)) ].
	^ members! !
